﻿// ActionScript 3.0クラス定義ファイル: EllipticMotion.as
package {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	public class EllipticMotion extends MovieClip {
		private const DEGREE_TO_RADIAN:Number = Math.PI/180;
		private var nDegree:Number = 0;
		private var nRadian:Number = 0;
		private var nSpeed:Number = 5;
		private var nCenterX:Number = stage.stageWidth/2;
		private var nCenterY:Number = stage.stageHeight/2;
		private var nRadiusX:Number = 100;
		private var nRadiusY:Number = 50;
		private var nCos:Number = Math.cos(nRadian);
		private var nSin:Number = Math.sin(nRadian);
		public function EllipticMotion() {
			addEventListener(Event.ENTER_FRAME, xMoveX);
			addEventListener(Event.ENTER_FRAME, xMoveY);
			addEventListener(Event.ENTER_FRAME, xScale);
			addEventListener(Event.ENTER_FRAME, xBlur);
			addEventListener(Event.ENTER_FRAME, xUpdate);
		}
		private function xMoveX(eventObject:Event):void {
			x = nCenterX+nCos*nRadiusX;
		}
		private function xMoveY(eventObject:Event):void {
			y = nCenterY+nSin*nRadiusY;
		}
		private function xUpdate(eventObject:Event):void {
			nDegree += nSpeed;
			nDegree = (nDegree%360+360)%360;
			nRadian = nDegree*DEGREE_TO_RADIAN;
			nCos = Math.cos(nRadian);
			nSin = Math.sin(nRadian);
		}
		private function xScale(eventObject:Event):void {
			scaleX = scaleY = xGetIndexZ(0.8, 1);
			scaleX *= xGetIndexZ();
		}
		private function xBlur(eventObject:Event):void {
			var nBlur:Number = xGetIndexZ(4, 0);
			var myBlur:BlurFilter = new BlurFilter(nBlur, nBlur/2);
			filters = [myBlur];
		}
		private function xGetIndexZ(nMin:Number=-1, nMax:Number=1):Number {
			if (isNaN(nMin) || isNaN(nMax)) {
				return NaN;
			}
			var nIndexZ:Number = (nMax-nMin)*(nSin+1)/2+nMin;
			return nIndexZ;
		}
	}
}