﻿// ActionScript 3.0クラス定義ファイル: EllipticMotion.as
package {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Point;
	public class EllipticMotion extends MovieClip {
		private const DEGREE_TO_RADIAN:Number = Math.PI/180;
		private var degree:Number = 0;
		private var speed:Number = 5;
		private var center:Point = new Point(stage.stageWidth/2, stage.stageHeight/2);
		private var radius:Point = new Point(100, 50);
		private var cos:Number = Math.cos(degree*DEGREE_TO_RADIAN);
		private var sin:Number = Math.sin(degree*DEGREE_TO_RADIAN);
		public function EllipticMotion() {
			addEventListener(Event.ENTER_FRAME, moveX);
			addEventListener(Event.ENTER_FRAME, moveY);
			addEventListener(Event.ENTER_FRAME, scale);
			addEventListener(Event.ENTER_FRAME, blur);
			addEventListener(Event.ENTER_FRAME, update);
		}
		private function moveX(eventObject:Event):void {
			x = center.x+cos*radius.x;
		}
		private function moveY(eventObject:Event):void {
			y = center.y+sin*radius.y;
		}
		private function update(eventObject:Event):void {
			degree += speed;
			degree = (degree%360+360)%360;
			var nRadian:Number = degree*DEGREE_TO_RADIAN;
			cos = Math.cos(nRadian);
			sin = Math.sin(nRadian);
		}
		private function scale(eventObject:Event):void {
			scaleX = scaleY = getIndexZ(0.8, 1);
			scaleX *= getIndexZ();
		}
		private function blur(eventObject:Event):void {
			var nBlur:Number = getIndexZ(4, 0);
			var myBlur:BlurFilter = new BlurFilter(nBlur, nBlur/2);
			filters = [myBlur];
		}
		private function getIndexZ(nMin:Number=-1, nMax:Number=1):Number {
			if (isNaN(nMin) || isNaN(nMax)) {
				return NaN;
			}
			var nIndexZ:Number = (nMax-nMin)*(sin+1)/2+nMin;
			return nIndexZ;
		}
	}
}