﻿package rotation{
	import flash.display.MovieClip;
	import flash.geom.Point;
	import flash.events.Event;
	import flash.events.EventDispatcher;  // 追加
	// public class RotationController {
	public class RotationController extends EventDispatcher {  // 継承を追加
		private static  const ROTATE:String = "rotate";  // 追加
		private var timeline_mc:MovieClip;
		private var center:Point;
		private var radius:Point;
		private var instances_array:Array = new Array();
		public function RotationController(my_mc:MovieClip, myCenter:Point=null, myRadius:Point=null) {
			timeline_mc = my_mc;
			if (myCenter is Point) {
				center = myCenter;
			} else {
				center = new Point(my_mc.stage.stageWidth/2, my_mc.stage.stageHeight/2);
			}
			if (myRadius is Point) {
				radius = myRadius;
			} else {
				radius = center.clone();
				radius.normalize(radius.length*0.7);
			}
		}
		public function addListener(my_mc:EllipticMotion):uint {
			var nInstances:uint = instances_array.push(my_mc);
			return nInstances;
		}
		public function removeListener(my_mc:EllipticMotion):void {
		}
		public function startRotation():void {
			var nInstances:uint = instances_array.length;
			var nDegree:Number = 360/nInstances;
			var my_mc:EllipticMotion;
			for (var i:int = 0; i<nInstances; i++) {
				my_mc = instances_array[i];
				timeline_mc.addChild(my_mc);
				my_mc.setPosition(i*nDegree, center, radius);
				addEventListener(ROTATE, my_mc.rotate);  // 追加
			}
			timeline_mc.addEventListener(Event.ENTER_FRAME, rotate);  // 追加
		}
		private function rotate(eventObject:Event):void {  // メソッドを追加
			var myEventObject:Event = new Event(ROTATE);
			dispatchEvent(myEventObject);
		}
	}
}