﻿// ActionScript 3.0クラス定義ファイル: RotationController.as
package rotation{
	import flash.display.MovieClip;
	import flash.geom.Point;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	public class RotationController extends EventDispatcher {
		// private static  const ROTATE:String = "rotate";
		private var timeline_mc:MovieClip;
		private var center:Point;
		private var radius:Point;
		private var instances_array:Array = new Array();
		private var sensitivity:Number = 0.1;  // 追加
		private var maxSpeed:Number = 15;  // 追加
		public function RotationController(my_mc:MovieClip, myCenter:Point=null, myRadius:Point=null) {
			timeline_mc = my_mc;
			if (myCenter is Point) {
				center = myCenter;
			} else {
				center = new Point(my_mc.stage.stageWidth/2, my_mc.stage.stageHeight/2);
			}
			if (myRadius is Point) {
				radius = myRadius;
			} else {
				radius = center.clone();
				radius.normalize(radius.length*0.7);
			}
		}
		public function addListener(my_mc:EllipticMotion):uint {
			var nInstances:uint = instances_array.push(my_mc);
			return nInstances;
		}
		public function removeListener(my_mc:EllipticMotion):void {
		}
		public function startRotation():void {
			var nInstances:uint = instances_array.length;
			var nDegree:Number = 360/nInstances;
			var my_mc:EllipticMotion;
			for (var i:int = 0; i<nInstances; i++) {
				my_mc = instances_array[i];
				timeline_mc.addChild(my_mc);
				my_mc.setPosition(i*nDegree, center, radius);
				// addEventListener(ROTATE, my_mc.rotate);
				addEventListener(RotationEvent.ROTATE, my_mc.rotate);
			}
			timeline_mc.addEventListener(Event.ENTER_FRAME, rotate);
		}
		private function rotate(eventObject:Event):void {
			// var myEventObject:Event = new Event(ROTATE);
			var myEventObject:RotationEvent = new RotationEvent();
			var speed:Number = (-center.x+timeline_mc.stage.mouseX)*sensitivity;
			speed = Math.min(Math.max(speed, -maxSpeed), maxSpeed);
			var altitude:Number = -center.y+timeline_mc.stage.mouseY;
			altitude = Math.min(Math.max(-radius.y, altitude), radius.y);
			myEventObject.setRotationInfo(speed, altitude, center, new Point(radius.x, radius.y));
			dispatchEvent(myEventObject);
			setOrder();
		}
		private function setOrder():void {
			var nInstances:uint = instances_array.length;
			instances_array.sortOn("indexZ", Array.NUMERIC);
			for (var i:int=0; i<nInstances; i++) {
				timeline_mc.setChildIndex(instances_array[i], i);
			}
		}
	}
}