﻿// ActionScript 3.0クラス定義ファイル: EllipticMotion.as
package rotation{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Point;
	public class EllipticMotion extends MovieClip {
		private const DEGREE_TO_RADIAN:Number = Math.PI/180;
		private var _degree:Number = 0;
		private var cos:Number = Math.cos(_degree*DEGREE_TO_RADIAN);
		private var sin:Number = Math.sin(_degree*DEGREE_TO_RADIAN);
		private var minScale:Number = 0.8;
		private var focalLength:Number = minScale/(1-minScale);
		private var currentScale:Number;
		public function EllipticMotion() {
		}
		// private function get degree():Number {
		protected function get degree():Number {
			return _degree;
		}
		// private function set degree(nDegree:Number):void {
		protected function set degree(nDegree:Number):void {
			_degree = (nDegree%360+360)%360;
			var nRadian:Number = _degree*DEGREE_TO_RADIAN;
			cos = Math.cos(nRadian);
			sin = Math.sin(nRadian);
			currentScale = focalLength/(focalLength+getIndexZ(1, 0));
		}
		public function get indexZ():Number {
			return getIndexZ();
		}
		public function setPosition(nDegree:Number, center:Point, radius:Point):void {
			degree = nDegree;
			setRotation(center, radius);
		}
		// private function setRotation(center:Point, radius:Point):void {
		protected function setRotation(center:Point, radius:Point):void {
			moveX(center.x, radius.x);
			moveY(center.y, radius.y);
			scale();
			blur();
		}
		internal function rotate(eventObject:RotationEvent):void {
			degree += eventObject.speed;
			var center:Point = new Point(eventObject.centerX, eventObject.centerY);
			var radius:Point = new Point(eventObject.radiusX, eventObject.altitude);
			setRotation(center, radius);
		}
		private function moveX(nCenterX:Number, nRadiusX:Number):void {
			x = nCenterX+cos*nRadiusX*currentScale;
		}
		private function moveY(nCenterY:Number, nRadiusY:Number):void {
			y = nCenterY+sin*nRadiusY*currentScale;
		}
		private function scale():void {
			scaleX = scaleY = currentScale;
			scaleX *= getIndexZ();
		}
		private function blur():void {
			var nBlur:Number = getIndexZ(4, 0);
			var myBlur:BlurFilter = new BlurFilter(nBlur, nBlur/2);
			filters = [myBlur];
		}
		private function getIndexZ(nMin:Number=-1, nMax:Number=1):Number {
			if (isNaN(nMin) || isNaN(nMax)) {
				return NaN;
			}
			var nIndexZ:Number = (nMax-nMin)*(sin+1)/2+nMin;
			return nIndexZ;
		}
	}
}