﻿// ActionScript 3.0クラス定義ファイル: Main.as
package {
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.events.Event;
	public class Main extends MovieClip {
		private var myPosition:Point=new Point(stage.stageWidth/2, stage.stageHeight/2);
		private var oRotations:Object = {x:0,y:0,z:0};
		private var images_array:Array = [Image0, Image1, Image2, Image3, Image4, Image5];
		private var nUnit:Number = 100/2;
		private var cubePoints_array:Array=new Array();
		private var holderSprite:Sprite = new Sprite();
		private var nSensitivity:Number = 1/500;
		private var faces_array:Array = new Array();
		public function Main() {
			setCubeData();
			addChild(holderSprite);
			holderSprite.x = myPosition.x;
			holderSprite.y = myPosition.y;
			initializeCube();
			drawCube();
			holderSprite.addEventListener(Event.ENTER_FRAME, drawCube);
		}
		private function setCubeData():void {
			cubePoints_array[0] = new Point3D(-nUnit, -nUnit, -nUnit);
			cubePoints_array[1] = new Point3D(-nUnit, nUnit, -nUnit);
			cubePoints_array[2] = new Point3D(nUnit, nUnit, -nUnit);
			cubePoints_array[3] = new Point3D(-nUnit, -nUnit, nUnit);
			cubePoints_array[4] = new Point3D(nUnit, -nUnit, nUnit);
			cubePoints_array[5] = new Point3D(nUnit, nUnit, nUnit);
			faces_array.push([0, 1, 2]);  // 前面
			faces_array.push([3, 4, 5]);  // 後面
			faces_array.push([4, 3, 0]);  // 上面
			faces_array.push([5, 2, 1]);  // 底面
			faces_array.push([1, 0, 3]);  // 左側面
			faces_array.push([2, 5, 4]);  // 右側面
		}
		private function initializeCube():void {
			var nLength:Number = faces_array.length;
			for (var i:Number=0; i<nLength; ++i) {
				var imageClass:Class = images_array[i];
				var mySprite:Sprite3D = new Sprite3D();
				holderSprite.addChild(mySprite);
				mySprite.vertex = faces_array[i];
				faces_array[i] = mySprite;
				mySprite.addChild(new Bitmap(new imageClass(0, 0)));
			}
		}
		private function drawCube(eventObject:Event=null):void {
			oRotations.x = -holderSprite.mouseY*nSensitivity;
			oRotations.y = holderSprite.mouseX*nSensitivity;
			var points2d:Array = transformCubePoints(cubePoints_array, oRotations);
			var nLength:Number=faces_array.length;
			for (var i:Number=0; i < nLength; ++i) {
				var mySprite:Sprite3D = faces_array[i];
				var n0:Number = mySprite.vertex[0];
				var n1:Number = mySprite.vertex[1];
				var n2:Number = mySprite.vertex[2];
				mySprite.transformSpritePoints(points2d[n0], points2d[n1], points2d[n2]);
			}
		}
		private function transformCubePoints(points_array:Array, oMyRotations:Object):Array {
			var points2D_array:Array = new Array();
			var nRadianX:Number = oMyRotations.x;
			var nRadianY:Number = oMyRotations.y;
			var nRadianZ:Number = oMyRotations.z;
			var nLength:Number = points_array.length;
			for (var i:Number=0; i < nLength; ++i) {
				var myPoint3D:Point3D = points_array[i];
				myPoint3D.rotate(nRadianX, nRadianY, nRadianZ);
				points2D_array[i] = new Point(myPoint3D.x, myPoint3D.y);
			}
			return points2D_array;
		}
	}
}