﻿// ActionScript 3.0クラス定義ファイル: Singleton.as
package {
	import flash.errors.IllegalOperationError;
	public class Singleton {
		private static  var instance:Singleton = null;  // インスタンスを格納する
		private static  var internallyCalled:Boolean = false;  // 内部呼出しかどうかを示すフラグ
		public function Singleton() {
			if (internallyCalled) {  // フラグが内部呼出しを示せば
				// 本来の処理を行う
				trace("constructor is called");  // テスト用
				internallyCalled = false;  // 内部呼出しのフラグを初期値に戻す
			} else {  // フラグが内部呼出しを示さなければ
				// エラーをthrow
				throw new IllegalOperationError("Use Singleton.getInstance() to get the instance");
			}
		}
		// Singletonクラスのインスタンスを返す静的メソッド
		public static function getInstance():Singleton {
			if (Singleton.instance == null) {  // インスタンスが未生成なら
				trace("instance is being created");  // テスト用
				internallyCalled = true;  // 内部呼出しのフラグを設定
				instance = new Singleton();  // コンストラクタメソッドを呼出す
			}
			return instance;  // 格納されたインスタンスを返す
		}
	}
}